Imports System.Text
Imports System.Reflection
Imports System.Security
Imports System.Runtime.InteropServices

Friend Class ZuneXPThemePatch
    Friend Shared Sub FixTheme()
        Dim builder1 As New StringBuilder(260)
        Dim builder2 As New StringBuilder(260)
        If GetCurrentThemeName(builder1, builder1.Capacity, builder2, builder2.Capacity, Nothing, 0) = 0 Then
            Dim themeName As String = builder1.ToString()

            If themeName.ToLower().EndsWith("\zune.msstyles") Then
                'reflect 
                Dim presentationFrameworkAsm As Assembly = Assembly.GetAssembly(GetType(System.Windows.Window))
                If presentationFrameworkAsm IsNot Nothing Then
                    Dim themeWrapper As Type = presentationFrameworkAsm.[GetType]("MS.Win32.UxThemeWrapper")
                    If themeWrapper IsNot Nothing Then
                        Dim themeColor As FieldInfo = themeWrapper.GetField("_themeColor", BindingFlags.[Static] Or BindingFlags.NonPublic)
                        Dim themeNameField As FieldInfo = themeWrapper.GetField("_themeName", BindingFlags.[Static] Or BindingFlags.NonPublic)

                        themeColor.SetValue(Nothing, "metallic")
                        themeNameField.SetValue(Nothing, "luna")
                    End If
                End If

            End If
        End If
    End Sub

    <SuppressUnmanagedCodeSecurity(), SecurityCritical(), DllImport("uxtheme.dll", CharSet:=CharSet.Auto)> _
    Private Shared Function GetCurrentThemeName(ByVal pszThemeFileName As StringBuilder, ByVal dwMaxNameChars As Integer, ByVal pszColorBuff As StringBuilder, ByVal dwMaxColorChars As Integer, ByVal pszSizeBuff As StringBuilder, ByVal cchMaxSizeChars As Integer) As Integer
    End Function
End Class